<?
/*
  Copyright (C) 2006-2008 Vladislav Staroselskiy (inet@vladstar.com)
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

  // FUNCTIONS //

  function list_folders($editdescr=false) {
    global $style,$script_path,$picture_folder,$new_folder_sign,$new_folder_days,$folders_order,$subfolders_order,$folder_description_file,$allowed_users,$allowed_ip;
    if ($folders=get_folder_content($script_path.$picture_folder,"D",($folders_order=="reverse"?"R":"A"))) {
      $folderdescr=get_descriptions($script_path.$picture_folder.$folder_description_file);
      foreach($folders as $foldername) {
        print "<a class=\"".$style."\" href=\"#".$foldername."\">".(isset($folderdescr[strtolower($foldername)])&&$folderdescr[strtolower($foldername)]?$folderdescr[strtolower($foldername)]:$foldername)."</a> ";
      }
      if (is_writable($script_path.$picture_folder.$foldername) && ((isset($_SERVER["PHP_AUTH_USER"]) && array_search($_SERVER["PHP_AUTH_USER"],$allowed_users)!==false) || array_search($_SERVER["REMOTE_ADDR"],$allowed_ip)!==false)) {
        print "&nbsp;&nbsp;&nbsp;".($editdescr?"<a class=\"".$style."\" href=\"?descr=0\">":"<b>").FOLDERS_SHOW.($editdescr?"</a>":"</b>")."/".(!$editdescr?"<a class=\"".$style."\" href=\"?descr=1\">":"<b>").FOLDERS_EDIT.(!$editdescr?"</a>":"</b>").FOLDERS_MODE;
      }
      print "<br>\n";
      foreach($folders as $foldername) {
        if (is_writable($script_path.$picture_folder.$foldername) && ((isset($_SERVER["PHP_AUTH_USER"]) && array_search($_SERVER["PHP_AUTH_USER"],$allowed_users)!==false) || array_search($_SERVER["REMOTE_ADDR"],$allowed_ip)!==false) && $editdescr) {
          print descr_form((isset($folderdescr[strtolower($foldername)])&&$folderdescr[strtolower($foldername)]?$folderdescr[strtolower($foldername)]:""),"",$foldername,30,255,"<h3 class=\"".$style."\">".$foldername."</h3>");
        } else {
          print "<hr class=\"".$style."\"><h3 class=\"".$style."\" id=\"".$foldername."\">".(isset($folderdescr[strtolower($foldername)])&&$folderdescr[strtolower($foldername)]?$folderdescr[strtolower($foldername)]:$foldername)."</h3>\n";
        }
        print "<ul class=\"".$style."\">\n";
        if (strrpos($foldername, "/")!=strlen($foldername)-1) { $foldername.="/"; }
        if ($subfolders=get_folder_content($script_path.$picture_folder.$foldername,"D",($subfolders_order=="reverse"?"R":"A"))) {
          foreach($subfolders as $subfoldername) {
            $subfolderdescr=get_descriptions($script_path.$picture_folder.$foldername.$folder_description_file);
            print "<li class=\"".$style."\">";
            if (is_writable($script_path.$picture_folder.$foldername) && ((isset($_SERVER["PHP_AUTH_USER"]) && array_search($_SERVER["PHP_AUTH_USER"],$allowed_users)!==false) || array_search($_SERVER["REMOTE_ADDR"],$allowed_ip)!==false) && $editdescr) {
              print descr_form(($subfolderdescr[strtolower($subfoldername)]?$subfolderdescr[strtolower($subfoldername)]:""),$foldername,$subfoldername,30,255,$subfoldername,"?path=".$foldername.$subfoldername);
            } else {
              print "<a class=\"".$style."\" href=\"?path=".$foldername.$subfoldername."\">".(isset($subfolderdescr[strtolower($subfoldername)])?$subfolderdescr[strtolower($subfoldername)]:$subfoldername)."</a>";
              if (filemtime($script_path.$picture_folder.$foldername.$subfoldername)>(time()-$new_folder_days*24*60*60)) {
                if (is_file($script_path.$new_folder_sign)) {
                  print " <img class=\"".$style."\" src=\"".$new_folder_sign."\">";
                } else {
                  print FOLDERS_NEW;
                }
              }
            }
            print "</li>\n";
          }
        }
        print "</ul>\n";
      }
    }
  }

  function create_thumbnail($picdir,$thumbnaildir,$filename) {
    global $thumbnail_max_width, $thumbnail_max_height, $thumbnail_quality, $new_folder_mode, $less_restrictive, $style;
    if (! is_file($picdir.$filename)) {
      // It's not a file
      return false;
    }
    if (! is_dir($thumbnaildir)) {
      // Create thumbnail directory, if it doesn't exist
      mkdir_recursive($thumbnaildir,$new_folder_mode);
    }
    if ($tsize=create_JPEG_from_image($picdir.$filename,$thumbnaildir.substr_replace($filename,".jpg",strrpos($filename,".")),$thumbnail_max_width,$thumbnail_max_height,$thumbnail_quality,$less_restrictive)) {
      return $tsize;
    } else {
      print "<p class=\"".$style."\">".MESSAGE_CANNOT_CREATE.MESSAGE_THUMBNAIL.MESSAGE_FROM.$filename.MESSAGE_PICTURE."</p>\n";
      return false;
    }
  }

  function get_folder_content($foldername,$listmode="D",$sortmode="R") {
    if (is_dir($foldername) && $dh=opendir($foldername)) {
      $arr=array();
      while ($name=readdir($dh)) {
        if ($name!="." && $name!="..") {
          if ($listmode=="F" && is_file($foldername.$name)) {
            $size=filesize($foldername.$name);
            $imginfo=@getimagesize($foldername.$name);
            $width=$imginfo[0];
            $height=$imginfo[1];
            $type=$imginfo['mime'];
            $allowed_mime_types=array();
            if (array_search('gd',get_loaded_extensions())!==false) {
              array_push($allowed_mime_types,"image/gif","image/jpeg","image/png","image/wbmp");
            }
            if (array_search('magickwand',get_loaded_extensions())!==false) {
              array_push($allowed_mime_types,"image/tiff");
              if (array_search('image.jpeg',$allowed_mime_types)===false) {
                array_push($allowed_mime_types,"image/jpeg");
              }
            }
            if ($width && $height && array_search($type,$allowed_mime_types)!==false) {
              $arr[$name]=array($name,$size,$width,$height);
            }
          } elseif ($listmode=="D" && is_dir($foldername.$name)) {
            $arr[$name]=$name;
          }
        }
      }
      closedir($dh);
      if ($sortmode=="A") {
        ksort($arr);
      } elseif ($sortmode=="R") {
        krsort($arr);
      }
      return $arr;
    } else {
      return false;
    }
  }

  function safe_path($path) {
    // Security measure: 
    // replace multiple "/" and "." to single ones to prevent accessing 
    // path outside of picture folder, using relative and "from root" paths
    return ltrim(preg_replace(array('/\.+/','/\/+/'),array('.','/'),$path),'/');
  }

  function escape($filename) {
    return rawurlencode($filename);
  }

  function unescape($filename) {
    return rawurldecode($filename);
  }

  function mkdir_recursive($dirName,$dirMode) {
    global $script_path;
    $oldmask=umask(0);
    $newDir="";
    foreach(split('/',$dirName) as $dirPart) {
     $newDir.=$dirPart."/";
     if (strcmp(substr($script_path,0,strlen($newDir)),$newDir)!=0 && ! is_dir($newDir)) { 
        mkdir($newDir,$dirMode) || die(MESSAGE_CANNOT_CREATE.$newDir.MESSAGE_FOLDER);
      }
    }
    umask($oldmask);
  }

  function show_image($path,$name=false,$res=false,$resize=false,$exif=false) {
    global $root,$script_path,$uri_path,$picture_folder,$thumbnail_folder,$picture_position,$thumbnail_border_size,$info_filename,$temp_folder,$resized_image_quality,$description_file,$folder_description_file,$list_of_resolutions,$less_restrictive,$show_description,$show_exif,$limited_exif_info,$disable_client_mode,$allowed_users,$allowed_ip,$description_file,$lock_file,$new_folder_mode,$style;
    if (strrpos($path, "/")!=strlen($path)-1) { $path.="/"; }
    $folderpath=$script_path.$picture_folder.$path;
    $thumbpath=$script_path.$thumbnail_folder.$path;
    // Check if lock file exists and delete it if already expired
    if (is_file($thumbpath.$lock_file)) {
      if ((filemtime($thumbpath.$lock_file)+ini_get("max_execution_time"))>time()) {
        print "<p class=\"".$style."\">".MESSAGE_LOCKED_FOLDER_1.((filemtime($thumbpath.$lock_file)+ini_get("max_execution_time"))-time()).MESSAGE_LOCKED_FOLDER_2."</p>\n";
        return false;
      } else {
        unlink($thumbpath.$lock_file) || die(MESSAGE_CANNOT_REMOVE.$thumbpath.$lock_file.MESSAGE_LOCK.MESSAGE_FILE);
      }
    }
    list($fldr,$subfldr)=split("/",$path,2);
    if ($picfiles=get_folder_content($folderpath,"F","A")) {
      $starttime=time();
      $thumbfiles=get_folder_content($thumbpath,"F","A");
      if (! is_dir($thumbpath)) mkdir_recursive($thumbpath,$new_folder_mode);
      // Get detailed info
      if (file_exists($thumbpath.$info_filename)) {
        $info_content=file($thumbpath.$info_filename);

        // ======================================================================
        // Code below is a conversion of info file to the new format
        // to be removed in a future releases
        if (count($info_content)==1 && preg_match('/^\d+$/',$info_content[0])) {
          echo "<p class=\"".$style."\">Converting ".$info_filename." file into new format...";
          if (! file_exists($thumbpath.$lock_file)) touch($thumbpath.$lock_file);
          $info_content=array();
          foreach($picfiles as $pfile=>$pparams) {
            if (isset($pparams[1]) && isset($thumbfiles[substr_replace($pfile,".jpg",strrpos($pfile,"."))][1])) {
              array_push($info_content,rawurlencode($pfile)." ".$pparams[1]." ".$thumbfiles[substr_replace($pfile,".jpg",strrpos($pfile,"."))][1]);
            }
          }
          echo " done.</p>";
        }
        // Code above is a conversion of info file to the new format
        // to be removed in a future releases
        // ======================================================================

        foreach($info_content as $temp) {
          if (preg_match('/^\S+\s\d+\s\d+$/',$temp)) {
            list($pname,$psize,$tsize)=split(" ",$temp,3);
            $info[rawurldecode($pname)]=array($psize,trim($tsize));
          }
        }
      }

      $position=$i=$tcounter=0;
      $oldmask=umask(0002);
      foreach($picfiles as $pfile=>$pparams) {
        $tfile=substr_replace($pfile,".jpg",strrpos($pfile,"."));
        if ($name && $name==$pfile) $position=$i;
        $i++;
        if (! isset($thumbfiles[$tfile]) || ! isset($info[$pfile]) || $info[$pfile][0]!=$pparams[1] || $info[$pfile][1]!=$thumbfiles[$tfile][1]) {
          // Create a lock file
          if (! file_exists($thumbpath.$lock_file)) touch($thumbpath.$lock_file);
          $tsize=create_thumbnail($folderpath,$thumbpath,$pfile);
          $info[$pfile]=array($pparams[1],$tsize);
          $tcounter++;
        }
        unset($thumbfiles[$tfile]);
      }
      if ($tcounter) print "<p class=\"".$style."\">".MESSAGE_THUMBNAILS_CREATED_1.$tcounter.MESSAGE_THUMBNAILS_CREATED_2.(time()-$starttime).MESSAGE_THUMBNAILS_CREATED_3."</p>\n";
      // Delete obsolete thumbnails
      foreach($thumbfiles as $tfile=>$tparams) {
        if (! file_exists($thumbpath.$lock_file)) touch($thumbpath.$lock_file);
        unlink($thumbpath.$tfile); // Remove obsolete thumbnails
      }
      $thumbfiles=get_folder_content($thumbpath,"F","A");
      if (file_exists($thumbpath.$lock_file)) { 
        // Save details into info file
        $temp="";
        foreach ($info as $pfile=>$pparams) {
          if (isset($thumbfiles[substr_replace($pfile,".jpg",strrpos($pfile,"."))])) {
            $temp.=rawurlencode($pfile)." ".$info[$pfile][0]." ".$info[$pfile][1]."\n";
          }
        }
        file_put_contents($thumbpath.$info_filename,$temp) || die(MESSAGE_CANNOT_WRITE.MESSAGE_INTO.$path.$info_filename.MESSAGE_INFO.MESSAGE_FILE);
        // Remove lock file
        unlink($thumbpath.$lock_file) || die(MESSAGE_CANNOT_REMOVE.$thumbpath.$lock_file.MESSAGE_LOCK.MESSAGE_FILE); 
      }
      umask($oldmask);

      print VIEW_RESOLUTION;
      foreach($list_of_resolutions as $curres) {
        list($hres,$vres)=split("x",$curres,2);
        if ($curres==$res) {
           print "<b>".$curres."</b> ";
        } else {
           print make_link($curres,$path.($name?urlencode($name):""),$hres,$resize,$exif)." ";
        }
      }
      if ($resize) {
        if ($res==0) {
           print "<b>".VIEW_ORIGINAL."</b> ";
        } else {
          print make_link(VIEW_ORIGINAL,$path.($name?urlencode($name):""),"0",$resize,$exif)." ";
        }
      }
      if (! $disable_client_mode) {
        print " | ".VIEW_RESIZE_ON;
        if ($resize) {
          print make_link(VIEW_SERVER,$path.($name?urlencode($name):""),$res,"0",$exif)."/<b>".VIEW_CLIENT."</b> ";
        } else {
          print "<b>".VIEW_SERVER."</b>/".make_link(VIEW_CLIENT,$path.($name?urlencode($name):""),$res,"1",$exif)." ";
        }
        print VIEW_SIDE;
      }
      print "| ".VIEW_PICTURES." <b>".count($picfiles)."</b><hr class=\"".$style."\">";
      print "<a class=\"".$style."\" href=\"./#".$fldr."\">".VIEW_FOLDERS_LIST."</a>";
      $descrfiles=get_descriptions($folderpath.$description_file);
      if ($name && isset($name)) {
        $endkey=find_key($picfiles,"e");
        $startkey=find_key($picfiles,"s");
        $prevkey=find_key($picfiles,"p",$name);
        $nextkey=find_key($picfiles,"n",$name);
        $imginfo=@getimagesize($picture_folder.$path.$name);
        $imgwidth=($resize&&$res?" width=".$res:"");
        $imgalign=($picture_position=="left"||$picture_position=="right"?" align=".$picture_position:"");
        $imgdescr=(isset($descrfiles[escape(strtolower($picfiles[$name][0]))])?$descrfiles[escape(strtolower($picfiles[$name][0]))]:"");
        if (array_search('exif',get_loaded_extensions())!==false && ($imginfo['mime']=="image/jpeg" || $imginfo['mime']=="image/tiff") && $exifdata=@exif_read_data($picture_folder.$path.$name,"ANY_TAG")) {
          // Get EXIF information from the file
          $imgexif=VIEW_EXIF_HEADER;
          $imgexif.="<table class=\"".$style."\">\n".get_exif($exifdata)."</table>\n";
        }
        $imgalt=" title=\"".($imgdescr?$imgdescr." ":"")."(".$picfiles[$name][0].", ".$picfiles[$name][2]."x".$picfiles[$name][3].", ".$picfiles[$name][1].VIEW_BYTES.")\"";
        print  " | <a class=\"".$style."\" href=\"?path=".$path."\">".VIEW_THUMBNAILS."</a> | ".($prevkey&&$name!=$startkey?make_link(VIEW_PREVIOUS_PICTURE,$path.urlencode($picfiles[$prevkey][0]),$res,$resize,$exif):VIEW_PREVIOUS_PICTURE)." - ".($nextkey&&$name!=$endkey?make_link(VIEW_NEXT_PICTURE,$path.urlencode($picfiles[$nextkey][0]),$res,$resize,$exif):VIEW_NEXT_PICTURE)." (".($position+1).VIEW_OF.count($picfiles).")";
        print (isset($exifdata)&&$exifdata&&$imgexif?" | ".($exif?
          make_link(VIEW_EXIF_HIDE,$path.($name?urlencode($name):""),$res,$resize,0):
          make_link(VIEW_EXIF_SHOW,$path.($name?urlencode($name):""),$res,$resize,1)):""
        );
      } else {
        $fldfiles=get_descriptions(dirname(rtrim($folderpath,"/"))."/".$folder_description_file,basename(rtrim($folderpath,"/")));
        $flddescr=(isset($fldfiles[strtolower(basename(rtrim($folderpath,"/")))])?$fldfiles[strtolower(basename(rtrim($folderpath,"/")))]:basename(rtrim($folderpath,"/")));
      }
      if ($picture_position=="bottom") {
        print "<p class=\"".$style."\">";
        show_thumbnails($picfiles,$thumbfiles,$descrfiles,safe_path($thumbnail_folder),$path,$name,$res,$resize,$exif,$thumbnail_border_size);
        print "</p>\n";
      }
      if ($name && isset($name)) {
        if ($show_description=="above" && $imgdescr) {
          print "<h2 class=\"".$style."\">".$imgdescr."</h2>\n";
        }
        if (is_writable($folderpath) && ((isset($_SERVER["PHP_AUTH_USER"]) && array_search($_SERVER["PHP_AUTH_USER"],$allowed_users)!==false) || array_search($_SERVER["REMOTE_ADDR"],$allowed_ip)!==false)) {
          print "<p class=\"".$style."\">".descr_form($imgdescr,$path,$name,90,255,VIEW_DESCRIPTION)."</p>\n";
        }
        if (! $resize) {
          $tmpfile=str_replace("/","_",$path.$res."_".substr_replace($name,".jpg",strrpos($name,".")));
          if (! is_dir($root.$temp_folder)) {
            // Create temp folder, if it doesn't exist
            mkdir_recursive($root.$temp_folder,$new_folder_mode);
          }
          create_JPEG_from_image($folderpath.$name,$script_path.$temp_folder.$tmpfile,$res,floor($res*3/4),$resized_image_quality,$less_restrictive,true) || print "<p class=\"".$style."\">".MESSAGE_CANNOT_CREATE.MESSAGE_TEMP.MESSAGE_FILE.$temp_folder.$tmpfile."</p>\n";
          $imgfilename=$temp_folder.escape($tmpfile);
        } else {
          $imgfilename=$picture_folder.$path.escape($name);
        }
        $img="<img class=\"".$style."\" src=\"".$imgfilename."\"".$imgwidth.$imgalign.$imgalt.">";
        if ($picture_position!="left" && $picture_position!="right") {
          print "<p class=\"".$style."\">";
        }
        print ($nextkey&&$name!=$endkey?make_link($img,$path.urlencode($picfiles[$nextkey][0]),$res,$resize,$exif):$img);
        if ($picture_position!="left" && $picture_position!="right") {
          print "</p>\n";
        }
        if ($show_description=="below" && $imgdescr) print "<h2 class=\"".$style."\">".$imgdescr."</h2>";
        if ($exif && isset($imgexif)) print $imgexif;
      } elseif (isset($flddescr)) {
        print "<h2 class=\"".$style."\">".$flddescr."</h2>\n";
      }
      if ($picture_position!="bottom") {
        if ($picture_position!="left" && $picture_position!="right") {
          print "<p class=\"".$style."\">";
        }
        show_thumbnails($picfiles,$thumbfiles,$descrfiles,safe_path($thumbnail_folder),$path,$name,$res,$resize,$exif,$thumbnail_border_size);
        if ($picture_position!="left" && $picture_position!="right") {
          print "</p>\n";
        }
      }
    } else {
      print "<p class=\"".$style."\">".MESSAGE_NO_SUPPORTED_IMAGES."</p>\n";
    }
    return;
  }

  function show_thumbnails($picfiles,$thumbfiles,$descrfiles,$thumbnail_folder,$path,$name,$res,$resize,$exif,$bordersize) {
    global $style;
    foreach($picfiles as $pfile=>$pparams) {
      $tfile=substr_replace($pfile,".jpg",strrpos($pfile,"."));
      if (file_exists($thumbnail_folder.$path.$tfile)) {
        $imgsrc="<img class=\"".$style."\" src=\"".$thumbnail_folder.$path.escape($tfile)."\"".($pfile==$name?" border=".$bordersize:"")." title=\"".(isset($descrfiles[strtolower($picfiles[$pfile][0])])?$descrfiles[strtolower($picfiles[$pfile][0])]." ":"").(isset($picfiles[$pfile])?"(".$picfiles[$pfile][0].", ".$picfiles[$pfile][2]."x".$picfiles[$pfile][3].", ".$picfiles[$pfile][1].VIEW_BYTES.")":"")."\">";
        print make_link($imgsrc,$path.escape($picfiles[$pfile][0]),$res,$resize,$exif)."\n";
      }
    }
    return;
  }

  function create_JPEG_from_image($sourcefilename,$destfilename,$newwidth=false,$newheight=false,$quality=75,$less_restrictive=false,$label=false) {
    global $write_text,$text_string,$text_ttf_font,$text_ttf_size,$text_ttf_angle,$text_color_red,$text_color_green,$text_color_blue,$text_position,$text_x_margin,$text_y_margin,$text_shadow,$allow_resolution_increase,$gd_method;
    if (is_file($sourcefilename)) {
      $imginfo=@getimagesize($sourcefilename);
      $width=$imginfo[0];
      $height=$imginfo[1];
      $type=$imginfo['mime'];
      if (! $width || ! $height) {
        // Cannot get image information (wrong type, corrupted, etc.)
        return false;
      } elseif ($newwidth && ! $newheight) {
        $newheight=floor($height*($newwidth/$width));
      } elseif ($newheight && ! $newwidth) {
        $newwidth=floor($width*($newheight/$height));
      } elseif ($newheight && $newwidth && ! $less_restrictive) {
        // Wee need to determine, which of the new sizes is more restrictive
        // and adjust another one to keep image in proportion
        if (floor($height*($newwidth/$width))>$newheight) {
          $newwidth=floor($width*($newheight/$height));
        } elseif (floor($width*($newheight/$height))>$newwidth) {
          $newheight=floor($height*($newwidth/$width));
        }
      } elseif ($newheight && $newwidth && $less_restrictive) {
        // Wee need to determine, which of the new sizes is less restrictive
        // and adjust another one to keep image in proportion
        if (floor($height*($newwidth/$width))<$newheight) {
          $newwidth=floor($width*($newheight/$height));
        } elseif (floor($width*($newheight/$height))<$newwidth) {
          $newheight=floor($height*($newwidth/$width));
        }
      }
      if ((! $newheight && ! $newwidth) || (! $allow_resolution_increase && $newwidth>$width)) {
        $newwidth=$width;
        $newheight=$height;
      }
      if (array_search('magickwand',get_loaded_extensions())!==false && ($type=='image/tiff' || $type=='image/jpeg' || $type=='image/gif' || $type=='image/png')) {
        // If ImageMagick is available, use it for JPEG and TIFF files
        $mw = NewMagickWand();
        MagickReadImage($mw, $sourcefilename);
        if (MagickGetImageColorspace($mw) == MW_CMYKColorspace) {
          MagickSetImageColorspace($mw, MW_RGBColorspace);
        }
        MagickSetImageFormat($mw, 'JPG' );
        MagickSetImageUnits($mw, MW_PixelsPerInchResolution);
        MagickResizeImage($mw, $newwidth, $newheight, MW_CubicFilter, 0.5);
        MagickSetCompressionQuality($mw, $quality);
        if ($label && $write_text) {
          $dw = NewDrawingWand();
          $i=0;
          DrawSetFont($dw,$text_ttf_font);
          DrawSetFontStyle($dw,MW_ItalicStyle);
          DrawSetFontSize($dw,$text_ttf_size+4);
          DrawSetGravity($dw,($text_position=="top"?MW_NorthWestGravity:MW_SouthWestGravity));
          $pw=NewPixelWand();
          if ($text_shadow) {
            PixelSetColor($pw,"rgb(128,128,128)");
            DrawSetFillColor($dw,$pw);
            if (MagickAnnotateImage($mw, $dw, $text_x_margin+1, $text_y_margin-1, $text_ttf_angle, $text_string) == 0) {
              echo MagickGetExceptionString($magick_wand);
            }
          }
          PixelSetColor($pw,"rgb(".$text_color_red.",".$text_color_green.",".$text_color_blue.")");
          DrawSetFillColor($dw,$pw);
          MagickAnnotateImage($mw, $dw, $text_x_margin, $text_y_margin, $text_ttf_angle, $text_string);
          DestroyPixelWand($pw);
          DestroyDrawingWand($dw);
        }
        MagickWriteImage($mw, $destfilename);
        DestroyMagickWand($mw);
        return filesize($destfilename); // return size of the image
      } elseif ($type=='image/jpeg' && (imagetypes() & IMG_JPG)) { 
        $source = imagecreatefromjpeg($sourcefilename);
      } elseif ($type=='image/gif' && (imagetypes() & IMG_GIF)) { 
        $source = imagecreatefromgif($sourcefilename);
      } elseif ($type=='image/png' && (imagetypes() & IMG_PNG)) { 
        $source = imagecreatefrompng($sourcefilename);
      } elseif ($type=='image/wbmp' && (imagetypes() & IMG_WBMP)) { 
        $source = imagecreatefromwbmp($sourcefilename);
      } else {
        // Not supported type
        return false;
      }
      // Create a picture
      $tmppic=imagecreatetruecolor($newwidth, $newheight);
      // Copy resized image
      if ($gd_method=="resample") {
        imagecopyresampled($tmppic, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
      } else {
        imagecopyresized($tmppic, $source, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
      }
      imagedestroy($source);
      if ($label && $write_text && $text_ttf_font && $text_string && $text_x_margin>0 && $text_x_margin<$newwidth && $text_y_margin>0 && $text_y_margin<$newheight && is_numeric($text_ttf_size) && $text_color_red>=0 && $text_color_red<=255 && $text_color_green>=0 && $text_color_green<=255 && $text_color_blue>=0 && $text_color_blue<=255) {
         if ($text_shadow) {
           imagettftext($tmppic, $text_ttf_size, $text_ttf_angle, ($text_x_margin+1), ($text_position=="top"?($text_y_margin+1):($newheight-$text_y_margin+1)), imagecolorallocate($tmppic,128,128,128), $text_ttf_font, $text_string);
         }
         imagettftext($tmppic, $text_ttf_size, $text_ttf_angle, $text_x_margin, ($text_position=="top"?$text_y_margin:($newheight-$text_y_margin)), imagecolorallocate($tmppic,$text_color_red,$text_color_green,$text_color_blue), $text_ttf_font, $text_string);
      }
      // Create JPEG
      if (imagejpeg($tmppic,$destfilename,$quality)) {
        // JPEG was successfully created
        imagedestroy($tmppic);
        return filesize($destfilename); // return size of the image
      } else {
        // We were not able to create a destination image
        imagedestroy($tmppic);
        return false;
      }
    } else {
      // File doesn't exist
      return false;
    }
  }

  function delete_expired_files($folder,$TTL=0) {
    if (is_dir($folder) && $dh=opendir($folder)) {
      while ($name=readdir($dh)) {
        if ($name!="." && $name!=".." && (filectime($folder.$name)+$TTL)<time()) {
          unlink($folder.$name) || die(MESSAGE_CANNOT_REMOVE.$folder.$name.MESSAGE_FILE);
        }
      }
      closedir($dh); 
    }
  }

  function make_link($content,$path,$res=false,$resize=false,$exif=false) {
    global $default_resolution,$style;
    return "<a class=\"".$style."\" href=\"?path=".$path.(($res!==false&&$res!=$default_resolution)?"&res=".$res:"").($resize?"&resize=".$resize:"").($exif?"&exif=".$exif:"")."\">".$content."</a>";
  }

  function check_folders() {
    global $script_path,$picture_folder,$thumbnail_folder,$folders_order,$subfolders_order;
    $i=0;
    if ($folders=get_folder_content($script_path.$thumbnail_folder,"D",($folders_order=="reverse"?"R":"A"))) {
      foreach($folders as $foldername) {
        if (strrpos($foldername, "/")!=strlen($foldername)-1) { $foldername.="/"; }
        if ($subfolders=get_folder_content($script_path.$thumbnail_folder.$foldername,"D",($subfolders_order=="reverse"?"R":"A"))) {
          foreach($subfolders as $subfoldername) {
            if (strrpos($subfoldername, "/")!=strlen($subfoldername)-1) { $subfoldername.="/"; }
            if (is_dir($script_path.$thumbnail_folder.$foldername.$subfoldername) && ! is_dir($script_path.$picture_folder.$foldername.$subfoldername)) {
              delete_expired_files($thumbnail_folder.$foldername.$subfoldername);
              if (rmdir($script_path.$thumbnail_folder.$foldername.$subfoldername)) {
                $i++;
              } else {
                die(MESSAGE_CANNOT_REMOVE.$thumbnail_folder.$foldername.$subfoldername.MESSAGE_FOLDER);
              }
            }
          }
        }
        if (is_dir($script_path.$thumbnail_folder.$foldername) && ! is_dir($script_path.$picture_folder.$foldername)) {
          delete_expired_files($thumbnail_folder.$foldername);
          if (rmdir($script_path.$thumbnail_folder.$foldername)) {
            $i++;
          } else {
            die(MESSAGE_CANNOT_REMOVE.$thumbnail_folder.$foldername.MESSAGE_FOLDER);
          }
        }
      }
    }
    return $i;
  }

  function get_descriptions($description_file,$filename=false) {
    $descrfiles=array();
    if (is_file($description_file) && filesize($description_file)>0) {
      foreach (file($description_file) as $key => $value) {
        list($fname,$fdescr)=split(" ",$value,2);
        if ($filename && $filename==strtolower($fname)) {
          // if filename is specified, return corresponding item only in array
          return $descrfiles[strtolower($fname)]=str_replace("\"","'",trim($fdescr));
        } else {
          $descrfiles[strtolower($fname)]=str_replace("\"","'",trim($fdescr));
        }
      }
      return $descrfiles;
    } else {
      return false;
    }
  }

  function update_descriptions($description_file,$fname,$fdescr) {
    $descr="";
    if (! $descrfiles=get_descriptions($description_file)) {
      $descrfiles=array();
    }
    $descrfiles[escape(strtolower($fname))]=str_replace("\"","'",trim($fdescr));
    ksort($descrfiles);
    foreach ($descrfiles as $key => $value) {
      $descr.=$key." ".$value."\n";
    }
    $oldmask=umask(0002);
    if (file_put_contents($description_file,$descr)===false) die(MESSAGE_CANNOT_WRITE.$description_file.MESSAGE_FILE);
    umask($oldmask);
    return;
  }

  function get_exif($exifdata) {
    global $show_exif,$limited_exif_info,$style;
    $imgexif="";
    foreach ($exifdata as $key => $value) {
      if (is_array($value)) {
        $imgexif.=get_exif($value);
      } else {
        if ($show_exif=="full" || ($show_exif=="limited" && array_search($key,$limited_exif_info,true)!==false) && $value!==false) {
          if ($key=="Flash") {
            if (($value&32) == 0) {
              if (($value&1) == 1) { 
                $flash = EXIF_FLASH_FIRED;
              } else {
                $flash = EXIF_FLASH_NOT_FIRED;
              }
              if (($value&24) == 1) {
                $flash .= ", ".EXIF_FLASH_COMP_FIRING;
              } elseif (($value&24) == 2) {
                $flash .= ", ".EXIF_FLASH_COMP_SUP;
              } elseif (($value&24) == 3) {
                $flash .= ", ".EXIF_FLASH_AUTO;
              }
              if (($value&6) == 2) {
                $flash .= ", ".EXIF_FLASH_NO_RET_LIGHT;
              } elseif (($value&6) == 3) {
                $flash .= ", ".EXIF_FLASH_RET_LIGHT;
              }
              if (($value&64) == 1) {
                $flash .= ", ".EXIF_FLASH_REDEYE;
              }
            } else {
              $flash = EXIF_FLASH_NOFLASH;
            }
            $value=$flash;
          }
          $imgexif.="<tr class=\"".$style."\"><th class=\"".$style."\">".$key."</th><td class=\"".$style."\">".$value."</td></tr>\n";
        }
      }
    }
    return $imgexif;
  }

  function descr_form($imgdescr,$path,$file,$size=90,$maxlen=255,$title="",$link="") {
    global $style;
    $ret ="<form  class=\"".$style."\" method=\"post\">\n";
    $ret.="<input class=\"".$style."\" type=\"hidden\" name=\"path\" value=\"".$path."\">\n";
    $ret.="<input class=\"".$style."\" type=\"hidden\" name=\"file\" value=\"".$file."\">\n";
    $ret.=($link?"<a class=\"".$style."\" href=\"".$link."\">":"").$title.($link?"</a><br>":"")." <input class=\"".$style."\" type=\"text\" name=\"descr\" value=\"".$imgdescr."\" size=".$size." maxlength=".$maxlen.">\n";
    $ret.="<input class=\"".$style."\" type=\"submit\" name=\"action\" value=\"".BUTTON_UPDATE."\">\n";
    $ret.="</form>\n";
    return $ret;
  }

  function find_key($arr,$type,$key=false) {
    krsort($arr);
    $keys = array_keys($arr);
    $ind = array_flip($keys);
    if (isset($keys[0]) && $type=="e") {
      // find and return end key
      return $keys[0];
    } elseif (isset($keys[count($keys)-1]) && $type=="s") {
      // find and return start key
      return $keys[count($keys)-1];
    } elseif (isset($keys[$ind[$key]-1]) && $type=="n") {
      // find and return next key
      return $keys[$ind[$key]-1];
    } elseif (isset($keys[$ind[$key]+1]) && $type=="p") {
      // find and return previous key
      return $keys[$ind[$key]+1];
    } else {
      return false;
    }
  }

  // For PHP 4.x compatibility:
  if (! function_exists('file_put_contents')) {
    function file_put_contents($filename,$contents) {
      if (is_file($filename)) { unlink($filename) || die(MESSAGE_CANNOT_REMOVE.$filename.MESSAGE_CANNOT_FILE); }
      $oldmask=umask(0);
      if ( ! $handle = fopen($filename, 'w')) die(MESSAGE_CANNOT_OPEN.$filename.MESSAGE_FILE);
      // I "love" when some documented PHP functions work the other way 
      // rather than they supposed to... fwrite() supposed to return number of 
      // written bytes, but always returns "0" in PHP 4.x instead...
      if (fwrite($handle, $contents)===false) die(MESSAGE_CANNOT_WRITE.$filename.MESSAGE_FILE);
      fclose($handle);
      umask($oldmask);
      // Therefore we'll return length of input $contents variable instead
      return strlen($contents);
    }
  }

  // For PHP 4.x compatibility: 
  if (! function_exists('file_get_contents')) {
    function file_get_contents($filename) {
      if ( ! $handle = fopen($filename, 'r')) die(MESSAGE_CANNOT_OPEN.$filename.MESSAGE_FILE);
      $contents = fread($handle, filesize($filename));
      fclose($handle);
      return $contents;
    }
  }
?>
